package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type SelfSupportForSchoolInfoDb struct {
	Db           *xorm.Engine `json:"db"`
	EnterpriseId int          `json:"enterprise_id"`
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) Set(enterpriseId int) { // set方法
	selfSupportForSchoolInfoDb.Db = Db
	selfSupportForSchoolInfoDb.EnterpriseId = enterpriseId
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) GetSelfSupportForSchoolInfo() (m *model.SelfSupportForSchoolInfo, err error) {
	m = new(model.SelfSupportForSchoolInfo)
	has, err := selfSupportForSchoolInfoDb.Db.Where("enterprise_id =?", selfSupportForSchoolInfoDb.EnterpriseId).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) FindSelfSupportForSchoolInfo(limit, start int) (*[]model.SelfSupportForSchoolInfo, error) {
	var m []model.SelfSupportForSchoolInfo
	if limit == 0 || start == 0 {
		if err := selfSupportForSchoolInfoDb.Db.Desc("id").Find(&m); err != nil {
			return nil, logx.Error(err)
		}
	} else {
		if err := selfSupportForSchoolInfoDb.Db.Desc("id").Limit(limit, start).Find(m); err != nil {
			return nil, logx.Error(err)
		}
	}
	return &m, nil
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) GetSelfSupportForSchoolInfoByName(name string) (m *model.SelfSupportForSchoolInfo, err error) {
	m = new(model.SelfSupportForSchoolInfo)
	has, err := selfSupportForSchoolInfoDb.Db.Where("name =?", name).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) SelfSupportForSchoolInfoInsert(m *model.SelfSupportForSchoolInfo) (int, error) {
	_, err := selfSupportForSchoolInfoDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) SelfSupportForSchoolInfoUpdate(m *model.SelfSupportForSchoolInfo, columns ...string) (int64, error) {
	affected, err := selfSupportForSchoolInfoDb.Db.Where("id =?", m.Id).Cols(columns...).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (selfSupportForSchoolInfoDb *SelfSupportForSchoolInfoDb) SelfSupportForSchoolInfoDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.SelfSupportForSchoolInfo{})
	} else {
		return Db.Where("id = ?", id).Delete(model.SelfSupportForSchoolInfo{})
	}
}
